diff -Nur linux-2.6.9-intc1/sound/oss/Kconfig linux-2.6.9-intc1-mih1/sound/oss/Kconfig
--- linux-2.6.9-intc1/sound/oss/Kconfig	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/sound/oss/Kconfig	2005-04-28 16:48:26.000000000 -0400
@@ -1096,16 +1096,39 @@
 	int "    DAC channel"
 	default "1"
 	depends on SOUND_SH_DAC_AUDIO
+
+config SOUND_WM97XX
+	tristate "WM97xx touch screen plugin"
+	depends on SOUND_PRIME!=n
+	
+config SOUND_WM9713
+	tristate "WM9713 touch screen plugin"
+	depends on SOUND_PRIME!=n
 	
 config SOUND_PXA
 	tristate "PXA Audio"
 	depends on SOUND_PRIME!=n && ARCH_PXA
 	
 config SOUND_PXA_AC97
-	tristate "PXA AC97 audio support"
-	depends on SOUND_PRIME!=n && SOUND_PXA
+       tristate 'Intel PXA250/210/27x AC97 audio'
+       depends on SOUND_PRIME!=n && SOUND_PXA
+       help
+         Say Y or M if you have a PXA cpu with an AC97 codec
+
+config SOUND_NO_SPEAKER_INIT
+	bool "Disable mixer initialization for SPEAKER"
+	depends on SOUND_PXA
 	help
-	  Say Y hear or M if you want to include support for AC97 audio.
+	  Say Y if you have a Glencoe board Rev.1.2 and
+	  hear noises from the Beeper after sound initialization
+
+config SOUND_PXA_WM97XX
+	tristate "PXA WM97xx continuous touch screen"
+	depends on SOUND_PRIME!=n && SOUND_PXA_AC97 && SOUND_WM97XX
+	
+config SOUND_PXA_WM97XX_BATT
+	tristate "PXA WM97xx Battery Monitor"
+	depends on SOUND_PRIME!=n && SOUND_PXA_AC97 && SOUND_WM97XX
 
 config SOUND_UCB1X00
 	tristate "UCB1X00 core support"
diff -Nur linux-2.6.9-intc1/sound/oss/Makefile linux-2.6.9-intc1-mih1/sound/oss/Makefile
--- linux-2.6.9-intc1/sound/oss/Makefile	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/sound/oss/Makefile	2005-03-22 15:20:31.000000000 -0500
@@ -79,10 +79,12 @@
 
 obj-$(CONFIG_SOUND_AD1980)	+= ac97_plugin_ad1980.o
 obj-$(CONFIG_SOUND_WM97XX)	+= ac97_plugin_wm97xx.o
+obj-$(CONFIG_SOUND_PXA_WM97XX) += pxa-wm97xx-touch.o
+obj-$(CONFIG_SOUND_PXA_WM97XX_BATT) += pxa-wm97xx-battery.o
 
-obj-$(CONFIG_SOUND_PXA) 		+= pxa-audio.o
+obj-$(CONFIG_SOUND_PXA) 	+= pxa-audio.o
 obj-$(CONFIG_SOUND_PXA_AC97) 	+= pxa-ac97.o ac97_codec.o
-obj-$(CONFIG_SOUND_UCB1X00)		+= ucb1x00-core.o
+obj-$(CONFIG_SOUND_UCB1X00)	+= ucb1x00-core.o
 obj-$(CONFIG_SOUND_UCB1X00_TS)	+= ucb1x00-ts.o
 
 ifeq ($(CONFIG_MIDI_EMU10K1),y)
diff -Nur linux-2.6.9-intc1/sound/oss/pxa-ac97.c linux-2.6.9-intc1-mih1/sound/oss/pxa-ac97.c
--- linux-2.6.9-intc1/sound/oss/pxa-ac97.c	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/sound/oss/pxa-ac97.c	2005-05-01 02:35:41.000000000 -0400
@@ -18,6 +18,9 @@
  *                Added codec init failure error detection, fast codec GPIO
  *                for PXA25x and PXA27x, new PXA27x AC97 read/write and
  *                shared the AC97 interrupt for use with codec specifig GPIO's.
+ *
+ *  Mar/Apr 2005: Matthias Ihmig <m.ihmig@mytum.de>
+ *                Modified for Glencoe and backport of some patches from later versions
  */
 
 #include <linux/init.h>
@@ -39,13 +42,20 @@
 #include <asm/semaphore.h>
 #include <asm/dma.h>
 #include <asm/arch/pxa-regs.h>
-#include <asm/arch/mainstone.h>
-
 #include "pxa-audio.h"
 
-/* We need a irq tag to request/free our shared irq handler */
-#define AC97_IRQ_TAG	0xac97c0de
-//#define DEBUG 1 
+#ifdef CONFIG_MACH_MAINSTONE
+	#include <asm/arch/mainstone.h>
+#endif
+#ifdef CONFIG_MACH_GLENCOE
+	#include <asm/arch/glencoe.h>
+#endif
+
+
+/* We need a dummy irq tag to request/free our shared irq handler */
+#define AC97_IRQ_TAG	(void*)0xac97c0de
+
+//#define DEBUG 1
 
 static DECLARE_MUTEX(CAR_mutex);
 
@@ -57,20 +67,23 @@
 static int pxa27x_read_wait(void)
 {
 	/* XLLP: timeout in reading and writing codec registers through AC link is 200us */
+        /* a PXA27x AC97 read takes 4 AC link frames to complete */
 	int timeout = 20;
+	u32 gsr;
 
 	while ( (!(GSR & GSR_SDONE)) && (timeout--) ) {
 		udelay(10);
 	}
 
-	GSR = GSR_SDONE | GSR_CDONE;
+	gsr = GSR;
+	GSR = gsr | GSR_SDONE | GSR_CDONE;
 
-	if (timeout < 0) {
+	if (timeout <= 0) {
 		printk(KERN_CRIT "%s: read codec register timeout.\n", __FUNCTION__);
 		return 0;
 	}
 #ifdef DEBUG
-	else{
+	else {
 		printk("\n<%s>: finish in %d us. \n",__FUNCTION__, (20-timeout)*10);
 	}
 #endif
@@ -80,6 +93,7 @@
 
 static int pxa27x_write_wait(void)
 {
+	u32 gsr;
 	/* XLLP: timeout in reading and writing codec registers through AC link is 200us */
 	int timeout = 20;
 
@@ -87,9 +101,12 @@
 		udelay(10);
 	}
 
-	GSR =  GSR_CDONE;
+	/* a PXA27x AC97 write takes 2 AC link frames to complete */
+	udelay (50);
+	gsr = GSR;
+	GSR = gsr | GSR_CDONE;
 
-	if (timeout < 0) {
+	if (timeout <= 0) {
 		printk(KERN_CRIT "%s: write codec register timeout.\n", __FUNCTION__);
 		return 0;
 	}		
@@ -194,7 +211,7 @@
 		wait_for_completion(&CAR_completion);
 
 		if (GSR & GSR_RDCS) {
-			GSR = GSR_RDCS;		//write a 1 to clear
+			GSR |= GSR_RDCS;		//write a 1 to clear
 			printk(KERN_CRIT "%s: read codec register timeout.\n", __FUNCTION__);
 		}
 
@@ -276,12 +293,13 @@
 #else
 	GCR = GCR_COLD_RST|GCR_CDONE_IE|GCR_SDONE_IE;
 #endif
-
-	/* XLLP: timeout in waiting for codec's ready signal during setup process is 500us */
+	/* link should be up after 10 uS */
+	udelay(10);
+	/* XLLP: timeout in waiting for codec's ready signal during setup process is 5ms */
 	while (!(GSR & GSR_PCR) && timeout--) {
-		udelay(10);
+		udelay(100);
 	}
-	if (timeout < 0) {
+	if (timeout <= 0) {
 		printk(KERN_CRIT "%s: cold reset codec timeout.\n", __FUNCTION__);
 		return 0;
 	}
@@ -303,10 +321,11 @@
 #else
 	GCR |= GCR_WARM_RST|GCR_CDONE_IE|GCR_SDONE_IE;
 #endif
+	udelay(500);
 
-	/* XLLP: timeout in waiting for codec's ready signal during setup process is 500us */
+	/* XLLP: timeout in waiting for codec's ready signal during setup process is 5ms */
 	while (!(GSR & GSR_PCR) && timeout--) {
-		udelay(10);
+		udelay(100);
 	}
 	if (timeout < 0) {
 		printk(KERN_CRIT "%s: warm reset codec timeout.\n", __FUNCTION__);
@@ -346,7 +365,15 @@
 #ifdef CONFIG_MACH_MAINSTONE
 		MST_MSCWR2 &= 0xffff000b;
 		pxa_gpio_mode(GPIO45_SYSCLK_AC97_MD);
-#endif	
+#endif
+
+#ifdef CONFIG_MACH_GLENCOE	
+		pxa_gpio_mode(GLN_GPIO_nAUDIO_PWR_DWN | GPIO_OUT);
+		GPIO_set(GLN_GPIO_nAUDIO_PWR_DWN);
+		
+		pxa_gpio_mode(GLN_GPIO_nAC97_INT | GPIO_IN);
+		set_irq_type(GLENCOE_nAC97_IRQ, IRQT_FALLING);
+#endif
 
 		pxa_gpio_mode(GPIO31_SYNC_AC97_MD);
 		pxa_gpio_mode(GPIO30_SDATA_OUT_AC97_MD);
@@ -357,7 +384,7 @@
 		 * Use GPIO 113 as AC97 Reset on Bulverde
 		 */
 #ifdef CONFIG_PXA27x
-		pxa_gpio_mode(113 | GPIO_ALT_FN_2_OUT);
+		pxa_gpio_mode(GPIO113_AC97_RESET_N_MD);
 #endif
 
 		/* 
@@ -383,10 +410,17 @@
 	MST_MSCWR2 &= ~0xc0;
 	pxa_gpio_mode(GPIO45_BTRTS_MD);
 #endif
+#ifdef CONFIG_MACH_GLENCOE
+	GPIO_clr(GLN_GPIO_nAUDIO_PWR_DWN);
+#endif
+
+#ifndef CONFIG_PXA27x
 	free_irq(IRQ_AC97, (void*)AC97_IRQ_TAG);
+#endif
+
 	GCR = GCR_ACLINK_OFF;
 	pxa_set_cken(CKEN2_AC97, 0);
-	printk(KERN_ERR "could not initialise AC97 codec.");
+	printk(KERN_ERR "could not initialise AC97 codec.\n");
 	return -ENODEV;
 }
 
@@ -399,6 +433,10 @@
 		MST_MSCWR2 &= ~0xc0;
 		pxa_gpio_mode(GPIO45_BTRTS_MD);
 #endif
+#ifdef CONFIG_MACH_GLENCOE
+		GPIO_clr(GLN_GPIO_nAUDIO_PWR_DWN);
+#endif
+
 		GCR = GCR_ACLINK_OFF;
 		pxa_set_cken(CKEN2_AC97, 0);
 #ifndef CONFIG_PXA27x 
@@ -479,7 +517,7 @@
 		      unsigned int cmd, unsigned long arg)
 {
 	int ret;
-	long val=0;
+	long val = 0;
 
 	switch(cmd) {
 	case SNDCTL_DSP_STEREO:
@@ -554,6 +592,83 @@
 	return pxa_audio_attach(inode, file, &ac97_audio_state);
 }
 
+static int pxa_ac97_suspend(struct device * dev, u32 state, u32 level)
+{
+	u16 reg, pwrmode;
+	int ret, i = 0;
+
+	if ( level != SUSPEND_POWER_DOWN )
+		return 0;
+
+	switch (state) {
+		case 1: pwrmode = AC97_PWR_D1; break;
+		case 2: pwrmode = AC97_PWR_D2; break;
+		case 3: pwrmode = AC97_PWR_D3; break;
+		default: return 1;
+	}
+
+	ret = ac97_suspend(&pxa_ac97_codec, state);
+	if (ret)
+		return ret;
+
+	/* now gracefully power down the codec and AC link */
+	reg = pxa_ac97_read(&pxa_ac97_codec, AC97_POWER_CONTROL);
+	reg |= (pwrmode & ~(AC97_PWR_PR6|AC97_PWR_PR5|AC97_PWR_PR4));
+	pxa_ac97_write(&pxa_ac97_codec, AC97_POWER_CONTROL, reg);
+	udelay(500);
+
+	reg = pxa_ac97_read(&pxa_ac97_codec, AC97_POWER_CONTROL);
+	reg |= pwrmode;
+	pxa_ac97_write(&pxa_ac97_codec, AC97_POWER_CONTROL, reg);
+
+	GCR |= GCR_ACLINK_OFF;
+	pxa_set_cken(CKEN31_AC97, 1);
+	while (!(GSR & (1 << 3)) && i < 99999)
+		i++;
+	pxa_set_cken(CKEN31_AC97, 0);
+	udelay(20); 
+	pxa_set_cken(CKEN2_AC97, 0);
+
+	return 0;
+}
+
+static int pxa_ac97_resume(struct device * dev, u32 level)
+{
+	if ( level != RESUME_POWER_ON ) 
+		return 0;
+
+	pxa_set_cken(CKEN2_AC97, 1);
+#ifdef CONFIG_MACH_MAINSTONE
+		MST_MSCWR2 &= 0xffff000b;
+#endif		
+	if (pxa_ac97_warm_reset() < 0) {
+		/* ok, warm reset didn't wake the codec, so we have to do 
+		 * a cold reset and restore the codec state 
+		 */
+		ac97_probe_codec(&pxa_ac97_codec);
+	} 
+	/* XLLP: timeout in waiting for codec's ready signal during setup process is 500us */
+	int timeout=50;
+	while (!(GSR & GSR_PCR) && timeout--) {
+		udelay(10);
+	}
+
+	if (timeout < 0) {
+		printk(KERN_CRIT "%s: resume codec timeout.\n", __FUNCTION__);
+	}
+#ifdef DEBUG
+	else{
+		printk("\n<%s>: finish in %d us. \n",__FUNCTION__, (50-timeout)*10);
+	}
+#endif
+
+	/* make sure that everything we need is powered up */
+	pxa_ac97_write(&pxa_ac97_codec, AC97_POWER_CONTROL, AC97_PWR_D0);
+	ac97_resume(&pxa_ac97_codec);
+
+	return 0;
+}
+
 /*
  * Missing fields of this structure will be patched with the call
  * to pxa_audio_attach().
@@ -565,7 +680,7 @@
 };
 
 
-static int pxa_ac97_probe(struct device *dev)
+static int __devinit pxa_ac97_probe(struct device *dev)
 {
 	int ret;
 	struct ac97_codec *dummy;
@@ -576,100 +691,45 @@
 
 	ac97_audio_state.dev_dsp = register_sound_dsp(&ac97_audio_fops, -1);
 	pxa_ac97_codec.dev_mixer = register_sound_mixer(&mixer_fops, -1);
-
+	ac97_audio_state.output_stream->dev = dev;
+	ac97_audio_state.input_stream->dev = dev;
+	
 	return 0;
 }
 
-static int pxa_ac97_remove(struct device *dev)
+static int __devexit pxa_ac97_remove(struct device *dev)
 {
 	unregister_sound_dsp(ac97_audio_state.dev_dsp);
 	unregister_sound_mixer(pxa_ac97_codec.dev_mixer);
 	pxa_ac97_put();
-
+	ac97_audio_state.output_stream->dev = NULL;
+	ac97_audio_state.input_stream->dev = NULL;
 	return 0;
 }
 
-/*
- * Suspend & Resume the PXA AC97 Controller.
- */
-static int pxa_ac97_suspend(struct device * dev,  u32 state, u32 level)
-{
-	if (level == SUSPEND_POWER_DOWN) {
-		/* initiate power-down of codec */
-		unsigned int pr;
-		int i = 0;
-			
-		printk("AC97 suspend\n");	
-		pr = pxa_ac97_read(&pxa_ac97_codec, AC97_POWER_CONTROL);
-		pr |= AC97_PWR_PR4;
-		pxa_ac97_write(&pxa_ac97_codec, AC97_POWER_CONTROL, pr);
-		GCR |= GCR_ACLINK_OFF;
-		pxa_set_cken(CKEN31_AC97, 1);
-		while (!(GSR & (1 << 3)) && i < 99999)
-			i++;
-		pxa_set_cken(CKEN31_AC97, 0);
-		udelay(20); 
-		pxa_set_cken(CKEN2_AC97, 0);
-	}
-	return 0;
-}
-
-static int pxa_ac97_resume(struct device * dev, u32 level)
-{	
-	if (level == RESUME_POWER_ON) {
-		printk("ac97 resume\n");
-		pxa_set_cken(CKEN2_AC97, 1);
-#ifdef CONFIG_MACH_MAINSTONE
-		MST_MSCWR2 &= 0xffff000b;
-#endif		
-
-		/* cold reset the codec */
-		GCR = 0;
-		pxa_set_cken(CKEN31_AC97, 1);
-		udelay(120);
-		pxa_set_cken(CKEN31_AC97, 0);	
-		GCR = GCR_COLD_RST;
-		udelay(30);
-	
-		/* XLLP: timeout in waiting for codec's ready signal during setup process is 500us */
-		int timeout=50;
-		while (!(GSR & GSR_PCR) && timeout--) {
-			udelay(10);
-		}
-	
-		if (timeout < 0) {
-			printk(KERN_CRIT "%s: resume codec timeout.\n", __FUNCTION__);
-		}
-#ifdef DEBUG
-		else{
-			printk("\n<%s>: finish in %d us. \n",__FUNCTION__, (50-timeout)*10);
-		}
-#endif
-	}
-	return 0;
-}
-
-static struct device_driver pxa_ac97_driver = {	
-	.name		=	"pxa2xx-ac97",
-	.probe    	=	pxa_ac97_probe,
-	.remove		=	pxa_ac97_remove,
-	.bus		=	&platform_bus_type,
-	.suspend	=	pxa_ac97_suspend,
-	.resume		=	pxa_ac97_resume,
+static struct device_driver pxa_ac97_driver = {
+	.name           = "pxa-ac97",
+	.bus            = &platform_bus_type,
+	.probe          = pxa_ac97_probe,
+	.remove         = pxa_ac97_remove,
+	.suspend        = pxa_ac97_suspend,
+	.resume         = pxa_ac97_resume,
+	.shutdown       = NULL,
 };
-
-static int __devinit pxa_ac97_init(void)
+ 
+static int __init pxa_ac97_init(void)
 {
 	return driver_register(&pxa_ac97_driver);
 }
 
 static void __exit pxa_ac97_exit(void)
 {
-	return driver_unregister(&pxa_ac97_driver);
+	driver_unregister(&pxa_ac97_driver);
 }
 
 module_init(pxa_ac97_init);
 module_exit(pxa_ac97_exit);
-MODULE_LICENSE("GPL");
-
 
+MODULE_AUTHOR("Nicolas Pitre");
+MODULE_DESCRIPTION("AC97 interface for the Cotula chip");
+MODULE_LICENSE("GPL");
diff -Nur linux-2.6.9-intc1/sound/oss/pxa-audio.c linux-2.6.9-intc1-mih1/sound/oss/pxa-audio.c
--- linux-2.6.9-intc1/sound/oss/pxa-audio.c	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/sound/oss/pxa-audio.c	2005-03-30 19:20:27.000000000 -0500
@@ -778,6 +778,9 @@
 
 	down(&state->sem);
 
+	/* set file to be nonseekable */
+	nonseekable_open(inode,file);
+
 	/* access control */
 	err = -ENODEV;
 	if ((file->f_mode & FMODE_WRITE) && !os)
diff -Nur linux-2.6.9-intc1/sound/oss/pxa-audio.h linux-2.6.9-intc1-mih1/sound/oss/pxa-audio.h
--- linux-2.6.9-intc1/sound/oss/pxa-audio.h	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/sound/oss/pxa-audio.h	2005-02-21 21:26:35.000000000 -0500
@@ -24,6 +24,7 @@
 	u_int dma_frag;			/* DMA fragment index */
 	u_int fragsize;			/* fragment size */
 	u_int nbfrags;			/* number of fragments */
+	struct device *dev;		/* device handle for DMA */
 	u_int dma_ch;			/* DMA channel number */
 	dma_addr_t dma_desc_phys;	/* phys addr of descriptor ring */
 	u_int descs_per_frag;		/* nbr descriptors per fragment */
diff -Nur linux-2.6.9-intc1/sound/oss/pxa-wm97xx-battery.c linux-2.6.9-intc1-mih1/sound/oss/pxa-wm97xx-battery.c
--- linux-2.6.9-intc1/sound/oss/pxa-wm97xx-battery.c	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/sound/oss/pxa-wm97xx-battery.c	2005-02-07 15:03:20.000000000 -0500
@@ -0,0 +1,212 @@
+/*
+ * wm97xx-battery.c  --  Battery monitor for
+ *                         Wolfson WM97xx AC97 Codecs.
+ *
+ * Copyright 2004 Wolfson Microelectronics PLC.
+ * Author: Liam Girdwood
+ *         liam.girdwood@wolfsonmicro.com or linux@wolfsonmicro.com
+ * Parts Copyright : Ian Molton <spyro@f2s.com>
+ *                   Andrew Zabolotny <zap@homelink.ru>
+ *
+ *  This program is free software; you can redistribute  it and/or modify it
+ *  under  the terms of  the GNU General  Public License as published by the
+ *  Free Software Foundation;  either version 2 of the  License, or (at your
+ *  option) any later version.
+ *
+ *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
+ *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
+ *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
+ *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
+ *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
+ *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
+ *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
+ *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  You should have received a copy of the  GNU General Public License along
+ *  with this program; if not, write  to the Free Software Foundation, Inc.,
+ *  675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ * Notes:
+ *     This code uses an API exposed by ac97_plugin_wm97xx to capture battery
+ *     data.
+ * 
+ *  Features:
+ *       - codecs supported:- WM9712, WM9713
+ *
+ *  Revision history
+ *    20th Sep 2004   Initial version.
+ * 
+ */
+
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/version.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/delay.h>
+#include <asm/uaccess.h>
+#include <asm/io.h>
+#include <asm/arch/pxa-regs.h>
+
+#include "wm97xx.h"
+
+#define TS_NAME			"wm97xx_battery"
+#define WM_TS_VERSION		"0.2"
+
+/*
+ * Battery sampling period jiffies.
+ */
+static int period = 2;
+module_param(period, int, 0);
+MODULE_PARM_DESC(period, "Battery sampling period (secs)");
+
+static struct wm97xx_device *dev;
+
+#ifdef CONFIG_PXA27x
+/*
+ * Sometimes the PXA27x cannot reset sticky codec GPIO's. In this case we
+ * also need to reset the GPIO in codec space.
+ */
+static int pxa27x_clear_sticky(int status)
+{
+	volatile u32 *reg_addr;
+	u32 gsr;
+
+	reg_addr = (u32 *)&PAC_REG_BASE + (0x54 >> 1);
+	*reg_addr = (status & ~WM97XX_GPIO_13) << 1;
+		
+	udelay(50);
+    gsr = GSR;
+    GSR = gsr & GSR_CDONE;
+ 
+	if (!(gsr & GSR_CDONE)) {
+		printk(KERN_CRIT "%s: write codec register timeout.\n", __FUNCTION__);
+        return 0;
+	}
+	return 1;
+}
+#endif
+
+
+/*
+ * PXA arch pen down handler.
+ */
+static int pxa_handler(int status)
+{
+	u32 gsr;
+#ifdef CONFIG_PXA27x
+	pxa27x_clear_sticky(status);
+#endif
+	gsr = GSR;
+	GSR = gsr & GSR_GSCI;
+	return 0;
+}
+
+static int battery_dead_handler(int status)
+{
+	printk("dead\n");
+	pxa_handler(status);
+	return 0;
+}
+
+static int battery_low_handler(int status)
+{
+	printk("low\n");
+	pxa_handler(status);
+	return 0;
+}
+
+static void battery_read (wm97xx_aux_conv_t ac, int stage)
+{
+	int val = 0;
+
+	if (stage) {
+		val = wm97xx_get_auxconv(dev, WM97XX_AC_BMON);
+		printk("got %d\n", val & 0xfff);
+	}
+}
+
+static int pxa_wm97xx_probe(void)
+{
+	/* register the battery alarm handlers */
+	switch (wm97xx_id & 0xffff) {
+		case WM9705_ID2:
+			return -ENODEV;
+		case WM9712_ID2:
+		case WM9713_ID2:
+			/* use the virtual PEN_DOWN GPIO to send irq over AC97 */
+			wm97xx_set_codec_irq(dev, IRQ_AC97, 1);
+			wm97xx_request_codec_event(dev, WM97XX_GPIO_14, battery_low_handler);
+			wm97xx_request_codec_event(dev, WM97XX_GPIO_15, battery_dead_handler);
+			GCR |= GCR_GIE;
+			break;
+	}
+	
+	/* register battery reader */
+	wm97xx_request_auxconv(dev, WM97XX_AC_BMON, period * HZ, battery_read);
+	return 0;
+}
+
+static int pxa_wm97xx_remove(void)
+{
+	wm97xx_free_auxconv(dev, WM97XX_AC_BMON);
+	
+	/* codec specific deconfig */
+	switch (wm97xx_id & 0xffff) {
+		case WM9712_ID2:
+		case WM9713_ID2:
+			/* disable interrupt */
+			if (wm97xx_clear_codec_irq(dev) == 0)
+				GCR &= ~GCR_GIE;
+			wm97xx_free_codec_event(dev, WM97XX_GPIO_14);
+			wm97xx_free_codec_event(dev, WM97XX_GPIO_15);
+			break;
+	}
+	return 0;
+}
+
+#if defined(CONFIG_PM)
+static int pxa_wm97xx_suspend(u32 state, u32 level)
+{
+	return 0;
+}
+
+static int pxa_wm97xx_resume(u32 level)
+{
+	return 0;
+}
+#else
+#define pxa_wm97xx_suspend NULL
+#define pxa_wm97xx_resume NULL
+#endif
+
+static struct wm97xx_device pxa_wm97xx_batt_driver = {
+        .name   = "pxa-wm97xx-battery",
+        .probe  = pxa_wm97xx_probe,
+        .remove = pxa_wm97xx_remove,
+        .suspend= pxa_wm97xx_suspend,
+        .resume = pxa_wm97xx_resume,
+		.cont_read = NULL,
+};
+
+static int __init pxa_wm97xx_battery_init(void)
+{
+	dev = &pxa_wm97xx_batt_driver;
+	return wm97xx_driver_register(dev);
+}
+
+static void __exit pxa_wm97xx_battery_exit(void)
+{
+	wm97xx_driver_unregister(dev);
+	dev = NULL;
+}
+
+/* Module information */
+MODULE_AUTHOR("Liam Girdwood <liam.girdwood@wolfsonmicro.com>");
+MODULE_DESCRIPTION("PXA WM97xx Battery Monitor");
+MODULE_LICENSE("GPL");
+
+module_init(pxa_wm97xx_battery_init);
+module_exit(pxa_wm97xx_battery_exit);
diff -Nur linux-2.6.9-intc1/sound/oss/pxa-wm97xx-touch.c linux-2.6.9-intc1-mih1/sound/oss/pxa-wm97xx-touch.c
--- linux-2.6.9-intc1/sound/oss/pxa-wm97xx-touch.c	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/sound/oss/pxa-wm97xx-touch.c	2005-02-26 15:12:27.000000000 -0500
@@ -0,0 +1,311 @@
+/*
+ * pxa-wm97xx-touch.c  --  PXA Continuous Touch screen driver for 
+ *                         Wolfson WM97xx AC97 Codecs.
+ *
+ * Copyright 2004 Wolfson Microelectronics PLC.
+ * Author: Liam Girdwood
+ *         liam.girdwood@wolfsonmicro.com or linux@wolfsonmicro.com
+ * Parts Copyright : Ian Molton <spyro@f2s.com>
+ *                   Andrew Zabolotny <zap@homelink.ru>
+ *
+ *  This program is free software; you can redistribute  it and/or modify it
+ *  under  the terms of  the GNU General  Public License as published by the
+ *  Free Software Foundation;  either version 2 of the  License, or (at your
+ *  option) any later version.
+ *
+ *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
+ *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
+ *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
+ *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
+ *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
+ *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
+ *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
+ *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  You should have received a copy of the  GNU General Public License along
+ *  with this program; if not, write  to the Free Software Foundation, Inc.,
+ *  675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ * Notes:
+ *     This code uses an API exposed by ac97_plugin_wm97xx to capture touch
+ *     data in a continuous manner on the Intel XScale archictecture
+ * 
+ *  Features:
+ *       - codecs supported:- WM9705, WM9712, WM9713
+ *       - processors supported:- Intel XScale PXA25x, PXA26x, PXA27x
+ *
+ *  Revision history
+ *    18th Aug 2004   Initial version.
+ * 
+ */
+
+#include <linux/module.h>
+#include <linux/moduleparam.h>
+#include <linux/version.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/delay.h>
+#include <asm/uaccess.h>
+#include <asm/io.h>
+#include <asm/arch/pxa-regs.h>
+
+#include "wm97xx.h"
+
+#define TS_NAME			"pxa_wm97xx_touch"
+#define WM_TS_VERSION		"0.4"
+
+#define WM97XX_PXA_SLOT		5
+
+/*
+ * The WM97xx codecs can signal a pen down event by either sending an irq over
+ * the AC97 link (not wm9705) or by asserting a pen down GPIO to interrupt the 
+ * OS. Set WM_PEN_DOWN_GPIO to 1 if you are using the dedicated GPIO to signal
+ * pen down events, otherwise set to 0 if you want to signal over the AC link.
+ */ 
+#define WM_PEN_DOWN_GPIO 0
+
+/*
+ * Pen sampling frequency in continuous mode.
+ *
+ * This parameter needs an additional architecture-dependent driver
+ * such as pxa-ac97-wm97xx.
+ *
+ * The sampling frequency is given by a number in range 0-3:
+ *
+ * 0: 93.75Hz  1: 187.5Hz  2: 375Hz  3: 750Hz
+ */
+static int cont_rate = 1;
+module_param(cont_rate, int, 0);
+MODULE_PARM_DESC(cont_rate, "Sampling rate in continuous mode (0-3, default 2)");
+
+
+/*
+ * Pen down detection.
+ * 
+ * This driver can either poll or use an interrupt to indicate a pen down
+ * event. If the irq request fails then it will fall back to polling mode.  
+ */
+static int pen_int = 1;
+module_param(pen_int, int, 0);
+MODULE_PARM_DESC(pen_int, "Pen down detection (1 = interrupt, 0 = polling)");
+
+/* flush AC97 slot 5 FIFO on pxa machines */
+#define PXA_FLUSH_FIFO    \
+	do {                  \
+		int count = 0;    \
+		for (; count < 16; count++) MODR; \
+		} while (0); 
+			
+static struct wm97xx_device *dev;		
+
+static int pxa_wm97xx_cont_read (struct input_dev* idev, int pen_down_time, int pressure)
+{
+	u16 x, y, p = 0x100 | WM97XX_ADCSEL_PRES;
+	int count = 0, find_x = 3;
+		 
+	/* sometimes there is stale data in the FIFO just after a pen down */
+	if (pen_down_time < 4 ) {
+		PXA_FLUSH_FIFO;
+		return RC_PENDOWN;
+	}
+
+	/* find the first X and sync */
+	while (find_x--) {
+		x = MODR;
+		if ((x & 0x7000) == WM97XX_ADCSEL_X)
+		 	break;
+	}
+
+	/* are we now syncronised X,Y[,P],X,Y[,P],X... ? */
+	if (!find_x)
+		return RC_PENDOWN;
+	
+	/* read Y [and pressure] */
+	y = MODR & 0xffff;
+	if (pressure)
+		p = MODR & 0xffff;
+	
+#ifdef CONFIG_PXA27x
+	while (MISR & (1 << 2)) {
+#else
+	while (count < 16) {
+#endif
+
+		/* are samples valid */
+		if ((x & 0x7000) != WM97XX_ADCSEL_X || 
+			(y & 0x7000) != WM97XX_ADCSEL_Y ||
+			(p & 0x7000) != WM97XX_ADCSEL_PRES)
+				goto next;
+		
+		/* is pen down pressure great enough ? */		
+		if (pressure && ((p & 0xfff) > pressure))
+			goto next;
+		
+		/* coordinate is good */
+		printk(KERN_DEBUG "x %x y %x p %x\n", x,y,p);
+		input_report_abs (idev, ABS_X, x & 0xfff);
+		input_report_abs (idev, ABS_Y, y & 0xfff);
+		input_report_abs (idev, ABS_PRESSURE, p & 0xfff);
+		input_sync (idev);
+
+next:		
+		x = MODR;
+		y = MODR;
+		count += 2;
+		if (pressure) {
+			p = MODR;
+			count++;
+		}
+	}
+
+	return RC_PENDOWN;
+}
+
+#ifdef CONFIG_PXA27x
+/*
+ * Sometimes the PXA27x cannot reset sticky codec GPIO's. In this case we
+ * also need to reset the GPIO in codec space.
+ */
+static int pxa27x_clear_sticky(int status)
+{
+	volatile u32 *reg_addr;
+	u32 gsr;
+
+	reg_addr = (u32 *)&PAC_REG_BASE + (0x54 >> 1);
+	*reg_addr = (status & ~WM97XX_GPIO_13) << 1;
+		
+	udelay(50);
+    gsr = GSR;
+    GSR = gsr & GSR_CDONE;
+ 
+	if (!(gsr & GSR_CDONE)) {
+		printk(KERN_CRIT "%s: write codec register timeout.\n", __FUNCTION__);
+        return 0;
+	}
+	return 1;
+}
+#endif
+
+
+/*
+ * PXA arch pen down handler.
+ */
+static int pxa_pen_handler(int status)
+{
+	u32 gsr;
+#ifdef CONFIG_PXA27x
+	pxa27x_clear_sticky(status);
+#endif
+	gsr = GSR;
+	GSR = gsr & GSR_GSCI;
+	return 0;
+}
+	
+
+static int pxa_wm97xx_probe(void)
+{
+	/* codec specific irq config */
+	if (pen_int) {
+		switch (wm97xx_id & 0xffff) {
+			case WM9705_ID2:
+				wm97xx_set_pen_irq(dev, IRQ_GPIO(4));
+				set_irq_type(IRQ_GPIO(4), IRQT_BOTHEDGE);
+				break;
+			case WM9712_ID2:
+			case WM9713_ID2:
+				/* enable pen down interrupt */
+#if WM_PEN_DOWN_GPIO
+				/* use the PEN_DOWN GPIO */
+				wm97xx_set_pen_irq(dev, GLENCOE_nAC97_IRQ);
+				wm97xx_config_codec_gpio(dev, WM97XX_GPIO_3, WM97XX_GPIO_OUT,
+					WM97XX_GPIO_POL_HIGH, WM97XX_GPIO_NOTSTICKY, WM97XX_GPIO_NOWAKE);
+#else
+				/* use the virtual PEN_DOWN GPIO to send irq over AC97 */
+				wm97xx_set_codec_irq(dev, IRQ_AC97, 1);
+				wm97xx_request_codec_event(dev, WM97XX_GPIO_13, pxa_pen_handler);
+				GCR |= GCR_GIE;
+#endif
+				break;
+			default:
+				printk("pen down irq not supported on this device\n");
+				pen_int = 0;
+				break;
+		}
+	}
+	
+	/* Go you big red fire engine */
+	wm97xx_set_continuous_mode (dev, pxa_wm97xx_cont_read, 1, WM97XX_PXA_SLOT, cont_rate);
+	return 0;
+}
+
+static int pxa_wm97xx_remove(void)
+{
+	/* codec specific deconfig */
+	if (pen_int) {
+		switch (wm97xx_id & 0xffff) {
+			case WM9705_ID2:
+				wm97xx_clear_pen_irq(dev);
+				break;
+			case WM9712_ID2:
+			case WM9713_ID2:
+				/* disable interrupt */
+#if WM_PEN_DOWN_GPIO
+				wm97xx_clear_pen_irq(dev);
+#else
+				if (wm97xx_clear_codec_irq(dev) == 0)
+					GCR &= ~GCR_GIE;
+				wm97xx_free_codec_event(dev, WM97XX_GPIO_13);
+#endif
+				break;
+		}
+	}
+	
+	wm97xx_set_continuous_mode (dev, NULL, 0, 0, 0);
+	return 0;
+}
+
+#if defined(CONFIG_PM)
+static int pxa_wm97xx_suspend(u32 state, u32 level)
+{
+	return 0;
+}
+
+static int pxa_wm97xx_resume(u32 level)
+{
+	return 0;
+}
+#else
+#define pxa_wm97xx_suspend NULL
+#define pxa_wm97xx_resume NULL
+#endif
+
+static struct wm97xx_device pxa_wm97xx_touch_driver = {
+        .name   = "pxa-wm97xx-touch",
+        .probe  = pxa_wm97xx_probe,
+        .remove = pxa_wm97xx_remove,
+        .suspend= pxa_wm97xx_suspend,
+        .resume = pxa_wm97xx_resume,
+		.cont_read = pxa_wm97xx_cont_read,
+};
+
+static int __init pxa_wm97xx_touch_init(void)
+{
+	dev = &pxa_wm97xx_touch_driver;
+	return wm97xx_driver_register(dev);
+}
+
+static void __exit pxa_wm97xx_touch_exit(void)
+{
+	wm97xx_driver_unregister(&pxa_wm97xx_touch_driver);
+	dev = NULL;
+}
+
+/* Module information */
+MODULE_AUTHOR("Liam Girdwood <liam.girdwood@wolfsonmicro.com>");
+MODULE_DESCRIPTION("AC97 continuous touch driver for PXA25x,PXA26x and PXA27x");
+MODULE_LICENSE("GPL");
+
+module_init(pxa_wm97xx_touch_init);
+module_exit(pxa_wm97xx_touch_exit);
diff -Nur linux-2.6.9-intc1/sound/oss/ucb1x00-core.c linux-2.6.9-intc1-mih1/sound/oss/ucb1x00-core.c
--- linux-2.6.9-intc1/sound/oss/ucb1x00-core.c	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/sound/oss/ucb1x00-core.c	2005-02-21 19:19:52.000000000 -0500
@@ -590,6 +590,12 @@
 	}
 #endif
 
+#ifdef CONFIG_MACH_GLENCOE
+	if (machine_is_glencoe()) {
+		ucb->irq = GLENCOE_nAC97_IRQ;
+	}
+#endif
+
 #ifdef CONFIG_PXA_CERF_PDA
 	if (machine_is_pxa_cerf()) {
 		irq_gpio_pin = CERF_GPIO_UCB1400_IRQ;
